class BaseChatStore {
}

class SimpleChatStore extends BaseChatStore {
    #store;
    setMessages(key, messages) {
        this.#store.set(key, messages);
    }
    getMessages(key) {
        return this.#store.get(key) ?? [];
    }
    addMessage(key, message, idx) {
        const messages = this.#store.get(key) ?? [];
        if (idx === undefined) {
            messages.push(message);
        } else {
            messages.splice(idx, 0, message);
        }
        this.#store.set(key, messages);
    }
    deleteMessages(key) {
        this.#store.delete(key);
    }
    deleteMessage(key, idx) {
        const messages = this.#store.get(key) ?? [];
        messages.splice(idx, 1);
        this.#store.set(key, messages);
    }
    getKeys() {
        return this.#store.keys();
    }
    constructor(...args){
        super(...args), this.#store = new Map();
    }
}

export { BaseChatStore, SimpleChatStore };
